//
//  DblBuffBmpImage.h
//  N80X
//
//  Created by hiroshi on 2021/08/20.
//

#ifndef DblBuffBmpImage_h
#define DblBuffBmpImage_h

#import <AppKit/AppKit.h>

typedef struct {
    UInt8    r;
    UInt8    g;
    UInt8    b;
    UInt8    a;
}    RGBPixel;

@interface DblBuffBmpImage : NSObject {

@private
    CGContextRef    _bmpctx1;
    CGContextRef    _bmpctx2;
    bool            _flip;
    void *          _bmp1;
    void *          _bmp2;
    NSRecursiveLock    *_lock;
}
@property (nonatomic, assign) int width;
@property (nonatomic, assign) int height;
//@property (nonatomic, assign) GLenum bpp;
@property (nonatomic, assign, getter=getBytesPerRow) const int bytesPerRow;
@property (nonatomic, readonly, getter=getBmpCtx) CGContextRef bmpctx;
@property (nonatomic, readonly, getter=getSecondBmpCtx) CGContextRef bmpctx_back;
@property (nonatomic, readonly, getter=getBitmap) const GLvoid *bitmap;
@property (nonatomic, readonly, getter=getSecondBitmap) const GLvoid *bitmap_back;

-(id)init:(int) p_width : (int) p_height;
-(void)flip;
-(RGBPixel*)getPixel:(BOOL)fore X:(int)x Y:(int)y;
-(void)setPixel:(BOOL)fore X:(int)x Y:(int)y R:(UInt8)r G:(UInt8)g B:(UInt8)b;
-(void)free;
-(void)lock;
-(void)unlock;

@end

#endif /* DblBuffBmpImage_h */
