//
//  N80.metal
//  N80X
//
//  Created by hiroshi on 2021/08/20.
//

#include <metal_stdlib>
using namespace metal;

struct VertexIn {
    float2 position;
    float2 pixel;
};
struct VertexOut {
    float4 position [[position]];
    float2 texcoord;
};

vertex VertexOut myVertexShader(
                                constant VertexIn *vertex_array [[ buffer(0) ]],
                                uint vid [[ vertex_id ]]) {
    VertexOut out;
    out.position = float4(vertex_array[vid].position, 0, 1);
    out.texcoord = vertex_array[vid].pixel;
    return out;
}
fragment half4 video_fragment(VertexOut vert [[stage_in]],
                              texture2d<float> tex2D [[texture(0)]]) {
    constexpr sampler s_quad(filter::linear);
    float4 color = tex2D.sample(s_quad, vert.texcoord);
    return half4(color);
}
