/**==========================================================================

	PC-8001 Device Emulator for Win32 Ver 1.10
	Copyright (C)1993-2010 H.Kanemoto

	This is a free software. You may copy or distribute
	it without any permissions. But there are NO WARRANTY
	of use. Entire risk of use is with you.

	External assembler functions for IBM-PC with VC++ 5.0
	last modified  Apr,4,1998.

;==========================================================================*/
#include "PC-8001.h"
#ifdef _MSC_VER
#include <windows.h>
#else
#include "../include/n80.h"
#include <string.h>
#endif
#ifdef __cplusplus
extern "C"
{
#endif
#define export
/**--------------------------------------------------------------------------
 **		ASM Modules
 **------------------------------------------------------------------------*/
static void _n80_new_pcg(BYTE ascii, BYTE port, BYTE dat)
{
	int	offset;

	switch (port) {
	case 0x00:	// Line data #0
	case 0x01:	// Line data #1
	case 0x02:	// Line data #2
	case 0x03:	// Line data #3
	case 0x04:	// Line data #4
	case 0x05:	// Line data #5
	case 0x06:	// Line data #6
	case 0x07:	// Line data #7
		offset = ((int)n80device.chiqlappe._bank * 2048) + ((int)ascii * 8) + port;
		n80device.pcg[offset] = dat;
		break;
	case 0x08:	// control
		n80device.chiqlappe._bank  = dat & 0x3;
		n80device.chiqlappe._swich = (dat & 0x4) == 4 ? 1 : 0;
		n80device.chiqlappe._block_mode = (dat & 0x8) == 8 ? 1 : 0;
		break;
	}
}
static void _n80_new_pcg_restore(void) {
	if (n80device.param.use_new_pcg)
		memcpy(n80device.pcg, n80device.font, 1024);
}
export void _n80_init_new_pcg(void) {
	n80device.chiqlappe.mode	= _n80_new_pcg;
	n80device.chiqlappe.restore	= _n80_new_pcg_restore;
}

#ifdef __cplusplus
}	// extern "C"
#endif
