/**--------------------------------------------------------------------------
 **
 **        NEC PC-8001 Emulator "N80" for MacOS X
 **        --------------------------------------------
 **        Copyright (c) 1993-2012 H.Kanemoto2
 **
 **        header file
 **
 **        Rev        Date        Descriptions
 **        -----    ----------    -----------------------------------------------
 **        1.00    2010/12/08    Zaurus SL-C3000 Fedora Core 10 ARMî≈ porting
 **        1.10    2012/08/22    MacOS X 10.7(Lion) or later porting
 **------------------------------------------------------------------------*/
#ifndef _N80_H_
#define _N80_H_
#include "n80types.h"
#include "z80.h"
/**--------------------------------------------------------------------------
 **    declare structure types
 **------------------------------------------------------------------------*/
typedef struct N80LX_tag {
    DWORD                   dot_npattern[8][256][8];    // narrow(width80) dot patterns [color][bit pattern][horizon]
    DWORD                   dot_wpattern[8][256][16];   // wide(width40) dot patterns [color][bit pattern][horizon]
    volatile int32_t        vram_sync;                  // PC-8001 vram sync
    volatile int32_t        request_cpu_signal;         // signal for z80 thread
    volatile DWORD          request_alsa_signal;        // signal for alsa thread
    volatile int32_t        request_disp_signal;        // signal for display thread
    int                     fn_on;                      // zaurus [Fn] key press status
    int                     sampling_rate;              // alsa pcm sampling rate
    int                     period_frames;              // alsa period length in samples
    int                     period_bytes;               // alsa period length in byte
    LPUSHORT                period_buffer;              // alsa local buffer
    int                     period_usec;                // alsa period long in micor sec
    double                  frame_keisu;                // 44.1khz(PCM) / 4MHz(CPU)
    int                     phase_adjuster;             // wave phase adjust (beep)
    int                     phase_adjuster2;            // wave phase adjust (pcg sound)
    BYTE                    cmt_buff[32*1024];          // CMT File cache
}   N80LX, *LPN80LX;

enum N80COLOR {N80BLACK = 0, N80BLUE, N80RED, N80PERPLE, N80GREEN, N80CYAN, N80YELLOW, N80WHITE};
#endif//_N80_H_
