//
//  n80em.h
//
//  Copyright (C) 1993-2019 Hiroshi Kanemoto.
//    Released under the MIT license
//    http://opensource.org/licenses/mit-license.php
//
//     Created:    2019/05/13    H.Kanemoto
//
#ifndef __N80GRAPH__
#define __N80GRAPH__
#import <Foundation/Foundation.h>
#import "DblBuffBmpImage.h"
#import "n80em.h"
#include "n80.h"
#include "pc-8001.h"
#include "libkern/OSAtomic.h"
#import <stdatomic.h>
#if TARGET_OS_IPHONE
#include "bytecoder.h"
#endif
//-----------------------------------------------------------------------------
//    Emulator Class
//-----------------------------------------------------------------------------
@interface n80graph : NSObject {
    @private
    LPDWORD             bitmap;        // current bitmap buffer
    atomic_int          drawsync;
    dispatch_queue_t    draw_queue;
    n80em               *n80em;
    NSRecursiveLock     *sync;
    int                 bltmode;
}

-(id)initWithN80:(n80em*)n80em;
-(void)start;
-(void)suspend;
-(void)resume;
-(void)reqDispose;
-(void)chg_bltfunc:(int)mode;
-(void)chg_palette:(bool)interrace;
-(void)draw_offscreen;
-(void)draw_config:(char[25][80])text attr:(char[25][80])attr;
-(void)draw_icon:(int)xpos ypos:(int)ypos;
-(void)lock;
-(void)unlock;

@end
#endif//__N80GRAPH__
