//
//  n80em.h
//
//  Copyright (C) 1993-2016 Hiroshi Kanemoto.
//    Released under the MIT license
//    http://opensource.org/licenses/mit-license.php
//
//     Created:    2012/08/22    H.Kanemoto
//    Modified:    2016/04/05    H.Kanemoto    ported from MaxOS X
//
#ifndef __N80_KEYBOARD__
#define __N80_KEYBOARD__
#import <GameController/GCKeyboard.h>
#import <GameController/GCKeyCodes.h>
#import "n80em.h"
#include "n80.h"
#include "pc-8001.h"
/*API_AVAILABLE(ios(14.0))*/
typedef struct /*API_AVAILABLE(ios(14.0))*/ keycodebind {
    GCKeyCode   code;
    BYTE        idx;
}   keycodebind, *pkeycodebind;
//-----------------------------------------------------------------------------
//    Sound Class
//-----------------------------------------------------------------------------
@interface n80keyboard : NSObject {
    @private
    n80em               *n80em;
    NSRecursiveLock     *sync;
}
@property (assign) bool tebkeyless;

-(id)initWithN80:(n80em*)n80em;
-(void)kb_keydown:(GCKeyCode)keycode API_AVAILABLE(ios(14.0));
-(void)kb_keyup:(GCKeyCode)keycode API_AVAILABLE(ios(14.0));
-(void)OnKeyDown:(BYTE)key code:(GCKeyCode)c;
-(void)OnKeyUp:(BYTE)key code:(GCKeyCode)c;
-(bool)toggle_tenkeyless;
-(void)set_tenkeyless:(bool)flag;

@end


#endif //__N80_KEYBOARD__
